logger_LANG = _K;
logger_INFO = '#FFF';
logger_ERROR = '#DC143C';
logger_WARN = '#B8860B';
logger_WEB_EVENT = 'false';
logger_thead = thread_number();

function logger_getTimeFormat(date) {
   var h = date.getHours();
   var m = date.getMinutes();
   var s = date.getSeconds();
   if (h < 10) h = "0" + h;
   if (m < 10) m = "0" + m;
   if (s < 10) s = "0" + s;
   return "[" + h + ":" + m + ":" + s + "]"
}

function logger_result() {
   logger_EN = _function_argument("en")
   logger_RU = _function_argument("ru")
   logger_NUMBER = _function_argument("number") || 1;
   logger_FORMAT_AS_LOG = _function_argument("formatAsLog")

   var msg = logger_LANG === 'ru' ? logger_RU : logger_EN;
   var fullMsg = msg;
   var actionId = null, date = null;

   if (logger_FORMAT_AS_LOG === 'true') {
      actionId = ScriptWorker.GetCurrentAction();
      date = new Date();
      fullMsg = '[' + actionId + '] ' + logger_getTimeFormat(date) + (logger_LANG === 'ru' ?' Поток №':' Thread#') + logger_thead + ': '  + msg;
   };

   result(fullMsg, logger_NUMBER - 1);

   _if(logger_WEB_EVENT === 'true', function () {
      var event = JSON.stringify({
         detail: { 
             type: 'result',
             thread: logger_thead,
             num: logger_NUMBER,
             id: actionId,
             date: date,
             msg: msg,
             fullMsg: fullMsg
         }
       });
      _web_interface_eval("document.dispatchEvent(new CustomEvent(\u0022customLog\u0022, " + event + "));")
   })!
}

function logger_getColorCode(colorName) {
   if (/^#/.test(colorName)) return colorName
   colorName = colorName.toLowerCase();
   var colors = {
      red: '#FF0000',
      orange: '#FFA500',
      yellow: '#FFFF00',
      green: '#7CFC00',
      cyan: '#00FFFF',
      blue: '#1E90FF',
      purple: '#DA70D6',
      white: '#FFF'
   }
   return colors[colorName.toLowerCase()];
}

function logger_settings() {
   logger_LANG = _function_argument("lang")
   logger_INFO = _function_argument("info")
   logger_ERROR = _function_argument("error")
   logger_WARN = _function_argument("warn")
   logger_WEB_EVENT = _function_argument("webEvent")
   logger_LEVEL = _function_argument("level")

   logger_INFO = logger_getColorCode(logger_INFO) || '#FFF';
   logger_ERROR = logger_getColorCode(logger_ERROR) || '#DC143C';
   logger_WARN = logger_getColorCode(logger_WARN) || '#B8860B';
   
   if ((logger_LANG === 'auto' || !logger_LANG) || (logger_LANG !== 'ru' && logger_LANG !== 'en')) {
      logger_LANG = _K;
   }
}


function logger_log_code() {
   logger_LEVEL = _function_argument("level")
   logger_COLOR = _function_argument("color")
   logger_EN = _function_argument("en")
   logger_RU = _function_argument("ru")

   if (logger_COLOR) {
      logger_COLOR = logger_getColorCode(logger_COLOR);
   } else {
      switch (logger_LEVEL) {
         case ('info'): {
            logger_COLOR = logger_INFO;
            break;
         }
         case ('warn'): {
            logger_COLOR = logger_WARN;
            break;
         }
         case ('error'): {
            logger_COLOR = logger_ERROR;
            break;
         }
         default: {
            logger_COLOR = '#fff';
         }
      }
   }
   var actionId = ScriptWorker.GetCurrentAction();
   var date = new Date();
   var msg = logger_LANG === 'ru'? logger_RU:logger_EN;
   var fullMsg = logger_getTimeFormat(date) + (logger_LANG === 'ru' ?' Поток №':' Thread#') + logger_thead + ': '  + msg;
   var html = '<div><a href="action://action' + actionId + '" style="color:#808080">[' + actionId + '] </a><span style="color:' + logger_COLOR + '">' + fullMsg + '</span></div>';

   log_html(html, '[' + actionId + '] ' + fullMsg)
   _if(logger_WEB_EVENT === 'true', function () {
      var event = JSON.stringify({
         detail: { 
             type: 'log',
             thread: logger_thead,
             level: logger_LEVEL,
             color: logger_COLOR,
             id: actionId,
             date: date,
             msg: msg,
             fullMsg: '[' + actionId + '] ' + fullMsg
         }
       });
      _web_interface_eval("document.dispatchEvent(new CustomEvent(\u0022customLog\u0022, " + event + "));")
   })!;
}

function logger_success() {
   logger_EN = _function_argument("en")
   logger_RU = _function_argument("ru")
   success(logger_LANG === 'ru'? logger_RU:logger_EN)
}

function logger_fail() {
   logger_EN = _function_argument("en")
   logger_RU = _function_argument("ru")
   logger_stopThread = _function_argument("stop")
   fail_user(logger_LANG === 'ru'? logger_RU:logger_EN, logger_stopThread)
}

function logger_die() {
   logger_EN = _function_argument("en")
   logger_RU = _function_argument("ru")
   logger_endInstantly = _function_argument("end")
   die(logger_LANG === 'ru'? logger_RU:logger_EN, logger_endInstantly)
}